-- MySQL Script generated by MySQL Workbench
-- Tue Jun 27 10:50:21 2017
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema seatbooking
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema seatbooking
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `seatbooking` DEFAULT CHARACTER SET utf8 ;
USE `seatbooking` ;

-- -----------------------------------------------------
-- Table `seatbooking`.`Usuario`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Usuario` (
  `idusuario` INT NOT NULL AUTO_INCREMENT,
  `idufsc` VARCHAR(45) NOT NULL,
  `email` VARCHAR(45) NOT NULL,
  `nome` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idusuario`, `idufsc`),
  UNIQUE INDEX `idusuario_UNIQUE` (`idusuario` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Horario`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Horario` (
  `idhorario` INT NOT NULL AUTO_INCREMENT,
  `valor` VARCHAR(5) NOT NULL,
  PRIMARY KEY (`idhorario`),
  UNIQUE INDEX `idhorario_UNIQUE` (`idhorario` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Onibus`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Onibus` (
  `idonibus` INT NOT NULL AUTO_INCREMENT,
  `marca` VARCHAR(45) NOT NULL,
  `modelo` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idonibus`),
  UNIQUE INDEX `idonibus_UNIQUE` (`idonibus` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Motorista`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Motorista` (
  `cpf` DECIMAL(10,0) NOT NULL,
  `nome` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`cpf`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Cidade`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Cidade` (
  `idcidade` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idcidade`),
  UNIQUE INDEX `idcidade_UNIQUE` (`idcidade` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Linha`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Linha` (
  `idlinha` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(45) NOT NULL,
  `idcidade` INT NOT NULL,
  PRIMARY KEY (`idlinha`),
  UNIQUE INDEX `idLinha_UNIQUE` (`idlinha` ASC),
  INDEX `idcidade_linha_idx` (`idcidade` ASC),
  CONSTRAINT `idcidade_linha`
    FOREIGN KEY (`idcidade`)
    REFERENCES `seatbooking`.`Cidade` (`idcidade`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Viagem`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Viagem` (
  `idviagem` INT NOT NULL AUTO_INCREMENT,
  `idhorario_partida` INT NOT NULL,
  `idonibus` INT NOT NULL,
  `idmotorista` DECIMAL(10,0) NOT NULL,
  `idlinha` INT NOT NULL,
  `idhorario_chegada` INT NOT NULL,
  PRIMARY KEY (`idviagem`),
  INDEX `idhorario_idx` (`idhorario_partida` ASC),
  INDEX `idonibus_idx` (`idonibus` ASC),
  INDEX `idmotorista_idx` (`idmotorista` ASC),
  INDEX `idhorario_chegada_idx` (`idhorario_chegada` ASC),
  INDEX `idlinha__idx` (`idlinha` ASC),
  CONSTRAINT `idhorario_partida_`
    FOREIGN KEY (`idhorario_partida`)
    REFERENCES `seatbooking`.`Horario` (`idhorario`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `idonibus_`
    FOREIGN KEY (`idonibus`)
    REFERENCES `seatbooking`.`Onibus` (`idonibus`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `idmotorista_v`
    FOREIGN KEY (`idmotorista`)
    REFERENCES `seatbooking`.`Motorista` (`cpf`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `idhorario_chegada_`
    FOREIGN KEY (`idhorario_chegada`)
    REFERENCES `seatbooking`.`Horario` (`idhorario`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `idlinha_`
    FOREIGN KEY (`idlinha`)
    REFERENCES `seatbooking`.`Linha` (`idlinha`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Assento`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Assento` (
  `idassento` INT NOT NULL AUTO_INCREMENT,
  `identificacao` VARCHAR(5) NOT NULL,
  `preferencial` INT NULL,
  `idonibus` INT NULL,
  PRIMARY KEY (`idassento`),
  INDEX `idonibus_idx` (`idonibus` ASC),
  UNIQUE INDEX `idassento_UNIQUE` (`idassento` ASC),
  CONSTRAINT `idonibus_a`
    FOREIGN KEY (`idonibus`)
    REFERENCES `seatbooking`.`Onibus` (`idonibus`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Reserva_periodica`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Reserva_periodica` (
  `idreserva_periodica` INT NOT NULL AUTO_INCREMENT,
  `data_inicio` DATE NOT NULL,
  `data_fim` DATE NOT NULL,
  `idusuario` INT NOT NULL,
  `idviagem` INT NOT NULL,
  PRIMARY KEY (`idreserva_periodica`),
  INDEX `idusuario_idx` (`idusuario` ASC),
  INDEX `idhorario_onibus_idx` (`idviagem` ASC),
  UNIQUE INDEX `idreserva_periodica_UNIQUE` (`idreserva_periodica` ASC),
  CONSTRAINT `idusuario_`
    FOREIGN KEY (`idusuario`)
    REFERENCES `seatbooking`.`Usuario` (`idusuario`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT,
  CONSTRAINT `idviagem_`
    FOREIGN KEY (`idviagem`)
    REFERENCES `seatbooking`.`Viagem` (`idviagem`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Reserva`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Reserva` (
  `data` DATE NOT NULL,
  `idusuario` INT NOT NULL,
  `idviagem` INT NOT NULL,
  `idassento` INT NOT NULL,
  `idreserva_periodica` INT NULL,
  PRIMARY KEY (`data`, `idusuario`, `idviagem`),
  INDEX `idusuario_idx` (`idusuario` ASC),
  INDEX `idonibus_horario_idx` (`idviagem` ASC),
  INDEX `idassento_idx` (`idassento` ASC),
  INDEX `idreserva_periodica_idx` (`idreserva_periodica` ASC),
  CONSTRAINT `idusuario_v`
    FOREIGN KEY (`idusuario`)
    REFERENCES `seatbooking`.`Usuario` (`idusuario`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `idviagem_v`
    FOREIGN KEY (`idviagem`)
    REFERENCES `seatbooking`.`Viagem` (`idviagem`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT,
  CONSTRAINT `idassento_v`
    FOREIGN KEY (`idassento`)
    REFERENCES `seatbooking`.`Assento` (`idassento`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT,
  CONSTRAINT `idreserva_periodica_v`
    FOREIGN KEY (`idreserva_periodica`)
    REFERENCES `seatbooking`.`Reserva_periodica` (`idreserva_periodica`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Parada`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Parada` (
  `idparada` INT NOT NULL AUTO_INCREMENT,
  `idcidade` INT NOT NULL,
  `local` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idparada`),
  INDEX `idcidade_idx` (`idcidade` ASC),
  UNIQUE INDEX `idparada_UNIQUE` (`idparada` ASC),
  CONSTRAINT `idcidade_`
    FOREIGN KEY (`idcidade`)
    REFERENCES `seatbooking`.`Cidade` (`idcidade`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Viagem_parada`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Viagem_parada` (
  `idviagem_parada` INT NOT NULL,
  `idparada` INT NOT NULL,
  PRIMARY KEY (`idviagem_parada`, `idparada`),
  INDEX `idparada_idx` (`idparada` ASC),
  CONSTRAINT `idparada_`
    FOREIGN KEY (`idparada`)
    REFERENCES `seatbooking`.`Parada` (`idparada`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `idviagem_parada`
    FOREIGN KEY (`idviagem_parada`)
    REFERENCES `seatbooking`.`Viagem` (`idviagem`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `seatbooking`.`Usuario_cidade`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `seatbooking`.`Usuario_cidade` (
  `idusuario_cidade` INT NOT NULL AUTO_INCREMENT,
  `idcidade` INT NOT NULL,
  `idusuario` INT NOT NULL,
  PRIMARY KEY (`idusuario_cidade`),
  INDEX `idcidade_idx` (`idcidade` ASC),
  INDEX `idusuario_idx` (`idusuario` ASC),
  UNIQUE INDEX `idusuario_cidade_UNIQUE` (`idusuario_cidade` ASC),
  CONSTRAINT `idcidade_uc`
    FOREIGN KEY (`idcidade`)
    REFERENCES `seatbooking`.`Cidade` (`idcidade`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `idusuario_uc`
    FOREIGN KEY (`idusuario`)
    REFERENCES `seatbooking`.`Usuario` (`idusuario`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
